<?php

namespace App\Modules\DefinedService\TypeDefinedService\Application\Delete;

use App\Http\History\HistoryTables;
use App\Modules\DefinedService\TypeDefinedService\Domain\IdTypeDefinedService;
use App\Modules\DefinedService\TypeDefinedService\Domain\IndexTypeDefinedService;
use App\Modules\DefinedService\TypeDefinedService\Domain\TypeDefinedServiceRepository;
use App\Modules\History\Application\Insert\InsertHistoryQuery;
use App\Modules\History\Domain\HistoryOperation;
use App\Modules\Shared\Domain\Bus\Event\EventBus;
use App\Modules\Shared\Domain\Bus\Query\QueryBus;
use App\Modules\Shared\Domain\Transaction;
use App\Modules\Versioner\Application\Check\VersionChecker;

final class TypeDefinedServiceDeleter
{
    public function __construct(
        private TypeDefinedServiceRepository $repository,
        private VersionChecker $versionChecker,
        private EventBus $eventBus,
        private QueryBus $queryBus,
        private Transaction $transaction
    ) {}

    public function __invoke(
        IdTypeDefinedService $id,
        int $idAdmin
    ) {
        $this->transaction->begin();
        $index = $this->repository->find(new IndexTypeDefinedService($id));
        $lastData = $index->toArray();
        $index->delete();
        $index->updateVersion();
        $index->updateDateUpdate();
        $this->repository->update($index);
        // $index->addUpdatedDomainEvent($idAdmin);
        // $this->eventBus->publishAll(...$index->pullDomainEvents());
        $this->queryBus->ask(new InsertHistoryQuery(
            json_encode([$lastData]),
            json_encode([]),
            HistoryOperation::DELETE,
            $index->id()->value(),
            $index->id()->value(),
            HistoryTables::TYPE_DEFINED_SERVICE,
            $idAdmin,
        ));
        $this->transaction->commit();
    }
}
